//
//  Controller.m
//  PeanutsView
//
//  Created by KOYAMA Yoshiaki on 05/12/15.
//  Copyright 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"

@implementation Controller

- (void)awakeFromNib {
}

// EBhEƂ̏
- (BOOL)windowShouldClose:(id)sender {
	[NSApp terminate:self];
    return YES;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
//    WebPreferences *preferences;
	WebFrame *frame;
	NSURL *url;
	NSURLRequest *request;
  
    _webView = [[WebView alloc] initWithFrame:NSZeroRect];
    [_webView setFrameLoadDelegate:self];

//    preferences = [_webView preferences];
//    [preferences setDefaultTextEncodingName:@"shift_jis"];

	frame = [_webView mainFrame];
	url = [NSURL URLWithString:@"http://snoopy.com/"];
	request = [NSURLRequest requestWithURL:url];

	[_indicator startAnimation:self];
    [frame loadRequest:request];
}

- (void)webView:(WebView *)sender didFinishLoadForFrame:(WebFrame *)frame {

/*
	/System/Library/Frameworks/WebKit.framework/Versions/A/Headers/DOMCore.h 
	DOMNode           : DOMObject <DOMEventTarget>
	DOMElement        : DOMNode

	/System/Library/Frameworks/WebKit.framework/Versions/A/Headers/DOMHTML.h
	DOMHTMLDocument   : DOMDocument
	DOMHTMLCollection : DOMObject

*/

    if ([sender mainFrame] != frame) {
		return;
	}

//  DOMHTMLDocument  DOMDocument pĂ܂B
//	DOMDocument	*document;
	DOMHTMLDocument	*htmlDocument;
	DOMHTMLCollection *collection;

//  DOMElement  DOMNode pĂ܂B
//	DOMNode *node;
	DOMElement *element;

	NSString *src, *com, *urlString;
	NSURL *url; 
	NSImage *image;
	NSSize size;
	int i;
	NSRange range;
	NSString *peanuts = @"/comics/peanuts/archive/images/peanuts";
/*
	ǂݍމ摜 SRC ="/comics/peanuts/archive/images/peanuts2073282060523.gif"
	peanuts2073282060523.gif  2073282060523 ͓tɂႢ܂Bǂ̂悤ɎZoꂽ̂A킩܂B
*/
	src = nil;

	// Objective-C ̎dg݂ɂĂ悭mȂ̂ŁȂ͖肪邩܂B
	htmlDocument = (DOMHTMLDocument	*)[frame DOMDocument];
	
//	NSLog(@"%@", document);
//	NSLog(@"%@", [[document documentElement] outerHTML]);
//	NSLog(@"%@", [document images]);

	range.location = 0;
	range.length = [peanuts length];

	collection = [htmlDocument images];
	for (i=0; i<[collection length]; i++) {

		// Objective-C ̎dg݂ɂĂ悭mȂ̂ŁȂ͖肪邩܂B
		element = (DOMElement *)[collection item:i];

//		node = [collection item:i];
//		NSLog(@"%@", node);


		// 擪w肵ʒu܂ł̕ /comics/peanuts/archive/images/peanuts ł邩ׂH
		if ([[element getAttribute:@"SRC"] compare:peanuts options:NSCaseInsensitiveSearch range:range] == NSOrderedSame) {
//		NSLog(@"[%d] %@", i, [element getAttribute:@"SRC"]);
			src = [element getAttribute:@"SRC"];
		}

/*		if (i==39) {
		src = [element getAttribute:@"SRC"];
		}
*/
	}

	if (src != nil) {

		com = @"http://snoopy.com/";
		urlString = [com stringByAppendingPathComponent:src];

		// C[W̓ǂݍ
		url = [NSURL URLWithString:urlString];
		image = [[NSImage alloc] initWithContentsOfURL:url];

		size = [image size];

		size.width += 10;
		size.height += 10;

		[_indicator stopAnimation:self];

		[_window setContentSize:size];
		[_imageView setImage:image];

	} else {
		[_indicator stopAnimation:self];
	}
}

@end
